To all those who are just starting their coding journey, you might not understand the code sometimes or even the question. But, that is completely fine. Just stick with it since you have chosen this journey with a purpose and have patience, which in my opinion, is the most important that a programmer must have. Be patient, give yourself time and practice whenever you can.
@floatingfortress721 Жыл бұрын
Well said!
@codeseverywhere Жыл бұрын
Thank You very much
@studymotivation-c8t Жыл бұрын
thank u, because of that exact same problem i quit leetcode twice before. This time im gonna stick to it no matter wat
@ayojohnson593311 ай бұрын
Greatly said!
@AdityaRaut-l6p9 ай бұрын
thank you
@jkk23-g7c Жыл бұрын
This solution is kind of a tricky one. I wouldn't be able to come up with this on my own, but yes once you explained it, it makes sense.
@iamabishekbaiju Жыл бұрын
couldn't agree more.
@leeroymlg4692 Жыл бұрын
that's becoming a pattern the more leetcode questions i come across lol
@nitiandiv Жыл бұрын
Same thing but in just slight more understanding way var removeDuplicates = function (A) { let pointer = 0; let i = 0; while (i < A.length) { let start = i; while (A[i] == A[i + 1]) { i++; } let end = i; const count = Math.min(2, end - start + 1); for (let x = 0; x < count; x++) { A[pointer] = A[end]; pointer++; } i++; } return pointer; };
@crikxouba Жыл бұрын
Even when explained to me as clearly as this, I always find these loops and pointers a complete mind f**k
@Dannyboyjr Жыл бұрын
I feel like ChatGPT's answer is easier to understand on this one. def removeDuplicates(self, nums: List[int]) -> int: left = 2 if len(nums)
@hida-steak-donburi10 ай бұрын
This solution is amazing... consider it a fixed-length sliding window
@sharaabsingh9 ай бұрын
Yeah, ChatGPT's solution is much more intuitive and easy to understand. Still thanks for your efforts Neetcode!
@winniethepooh.7 ай бұрын
I agree. It's pretty similar to his solution from his Remove Duplicates from Sorted Array video (kzbin.info/www/bejne/enatco14ppV5eqM). It was my inital apporach when solving this problem!
@sidazhong20196 ай бұрын
well, in similar question #26, you just change every "left - 2" to "left - 1". that work too.
@sergiofranklin8809 Жыл бұрын
def removeDuplicates(self, nums): j, count = 1, 1 for i in range(1, len(nums)): if nums[i] == nums[i - 1]: count += 1 else: count = 1 if count
@RuslanZinovyev6 ай бұрын
There is a way simpler solution and more intuitive from my perspective, I can't say that your explanation was really helpful this time, but I really appreciate what you are doing for us. def removeDuplicates(nums: List[int]) -> int: if len(nums)
@shaguntripathi8415 Жыл бұрын
In the Constraints: 1
@EjazAhmed-pf5tz Жыл бұрын
Thank you so much sir, but could you please combine videos in a playlist so that will be easy for us to follow
@vigneshs185211 ай бұрын
The fact i can write the solution with O(n^2) but still here to optimize the solution...Thank you bro
@kaytim414 Жыл бұрын
An alternative solution building off of the Remove Duplicates from Sorted Array I solution: class Solution: def removeDuplicates(self, nums: List[int]) -> int: left = 1 freq = 1 for i in range(1, len(nums)): if nums[i] > nums[left - 1]: nums[left] = nums[i] left += 1 freq = 1 elif nums[i] == nums[left - 1] and freq < 2: nums[left] = nums[i] left += 1 freq += 1 return left Instead of nested loops I added a var that keeps track of how many times a value is added and an elif that adds up to two of a given value.
@dash2714 Жыл бұрын
Love your videos, they are very insightful and helpful. I'm very greatful for you. I would like this time to share my solution to it, as for the first time ever it has a cleaner approach. Same idea with L and R pointers. with each iteration replace L with R, then check if L is valid, as follows: class Solution: def removeDuplicates(self, nums: List[int]) -> int: l = 2 for r in range(2, len(nums)): nums[l] = nums[r] if nums[l] != nums[l - 2]: l += 1 return l
@Prince-ol5zkАй бұрын
Your solution confused me, but i get the point of what you're doing. I struggled to get my code to be O(1) space. I used a dictionary to keep track of the frequency of each element. I finally optimized my solution by removing the dictionary
@VikasReddyVenkannagari7 ай бұрын
For those, who want a more stricter solution. The relative order is not preserved in this solution, if there are 4 3's [2, 3,3,3,3], we should consider the relative ordering where the first two 3's are considered, but the your solution kinda considers the last occurence of 3.
@luizelias6155Ай бұрын
I've wrote just the exact same as the previous one but instead of comparing with the value BEFORE I'm comparing with the two values AFTER: Javascript: var removeDuplicates = function(nums) { let L = 0; for (let R = 0; R < nums.length; R++) { if (nums[R] !== nums[R + 1] || nums[R] !== nums[R + 2]) { nums[L] = nums[R]; L++; } } return L; }; in JS, if I try to get an index that is out of bounds, it's just going to be undefined so everything works. The value needs to be different than the next two values so if you have: 1, 1, 1, 1, 1, 2, 2, 3... the check is going to fail for the first three 1s but pass on the last two so we'll end up with exactly two 1s as the result 1, 1, 2, 2, 3, 1, 1, 1 k = 5 so: 1, 1, 2, 2, 3
@PrajwalCanonShutterАй бұрын
I don't think the time complexity is O(n). Just image the input is --> [0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2] the inner for loop runs as many times as there are repeated numbers, correct me if Im wrong please !
@p8ul9 ай бұрын
simpler version: function removeDuplicates(nums: number[]): number { // edge case to return early if 2 or fewer elements if (nums.length
@Jaeoh.woof765 Жыл бұрын
My solution is very similar to the 1st version of the problem but with a slight twist. Runtime beats 98% ====================== def removeDuplicates(self, nums: List[int]) -> int: l = 2 flag = 0 for r in range(2, len(nums)): if nums[r] != nums[r-2-flag]: nums[l] = nums[r] l +=1 else: flag +=1 return l
@cupidchakma64485 ай бұрын
Is the time complexity O(n)^2 ? Since we are using 2 loops for the worst case?
@parthphalke4444 Жыл бұрын
Thank you for your efforts for the fellow community !🤟
@simsekcool95957 ай бұрын
I found it easier to use a set to solve this question and the first version of this question as well. I just check if the element we are currently at is already in both sets. If its in neither or in just one of the sets, then I added it to the other set and I swap the element at r and the element at i. But if the element is already in both sets, then I only increment r and don't do any swapping. Here is the code: sett1= set() sett2= set() i = 0 for r in range(len(nums)): if nums[r] not in sett2: if nums[r] not in sett1: #case where its not in either set sett1.add(nums[r]) nums[i], nums[r] = nums[r], nums[i] i+=1 else: #case where its not in set 2 but its in set1 sett2.add(nums[r]) nums[i], nums[r] = nums[r], nums[i] i+=1 #case where its in both sets return i
@niccpolitic612919 күн бұрын
This is easier, but much less time efficient.
@uptwist2260 Жыл бұрын
Thanks for the solution. Very easy to follow and reason.
@janki-bx1rn6 ай бұрын
Way easier solution from ChatGPT, easy to understand and much more intuitive class Solution: def removeDuplicates(self, nums: List[int]) -> int: if len(nums)
@shyamsudheer8335 Жыл бұрын
at 0.55 why is it better to shift the value to the end instead of popping because both have time complexity of O(n)?
@AustinCS2 ай бұрын
class Solution: def removeDuplicates(self, nums: List[int]) -> int: l = 1 count = 1 for r in range(1, len(nums)): if nums[r] != nums[r-1]: count = 0 if count < 2: nums[l] = nums[r] l += 1 count += 1 return l Initialize count to 1 and both pointers to the first index. We may need to reset the count and write in the same iteration when we find a new element. First check if the current element is a duplicate. If it isn't reset the count to 0. Then if the count is < 2 write the current element to the left pointer and increment the left pointer. Let the for loop handle the right pointer increment. return the left pointer.
@iamabishekbaiju Жыл бұрын
My solution took 50 minutes and 38 lines of code.
@arpitsharma769510 ай бұрын
Thank You for all the videos but what are your thoughts on below solution? I avoid another for loop. I use your r+1 logic. class Solution: def removeDuplicates(self, nums: List[int]) -> int: r=1 while r < len(nums)-1: while r+1
@asmamir78782 ай бұрын
Beautiful 🙌
@shivansh.speaks Жыл бұрын
class Solution { public: int removeDuplicates(vector& nums) { int len = nums.size(); if (len
@mojal8400Ай бұрын
The solution was awsome. Can you tell me some thing honestly? How did you learn this? I always have a big question in my mind, seniors like you how learned this? Pleas tell me.
@saksahmkumarsaksham3 ай бұрын
def removeDuplicates(self, nums): if len(nums)
@andrewcenteno34625 ай бұрын
simple solution, but the intutition behind it is tough
@tirasjeffrey20027 ай бұрын
i came up with an NlogN solution but broke my head trying to move the duplicate spots to the end,,,,,this one is very smart :0
@PJ-nc4jh4 ай бұрын
My logic was to check if (nums[i] == nums[i-1]) and (nums[i] == nums[i+1]) then i would push nums[i+1] to the back, but i got lost in the logic behind switching. Any comments/guidance regarding this would be appreciated
@prashant.s.397 Жыл бұрын
Super fantastic explanation ,found best algorithm from u ,watched others tutorials but they are just making it complex,it is very easy to solve via your method and also quite easily understandable
@satwiktatikonda764 Жыл бұрын
is there any reason for not uploading daily challenges ?
@ruthlessogre2441 Жыл бұрын
Here's the way i did it. maybe it's faster def removeDuplicates(self, nums) -> int: j = 1 for i in range(2,len(nums)): x = nums[i] if x != nums[i-1] or x != nums[i-2]: j += 1 nums[j] = x if i == j + 1 and i + 1 < len(nums) and x == nums[i+1]: j += 1 return j+1
@tomiwaadedokun6638 Жыл бұрын
Great work @NeetCodeIO Was thinking you actually stopped uploading daily leetcode video explanations when I didn't get any notification over the past few hours
@shuddhendushekharmishra6958 Жыл бұрын
# Another Soluion class Solution: def removeDuplicates(self, nums: List[int]) -> int: i = 0 counter = 0 l = len(nums) while i < (l-1): if nums[i] == nums[i+1] and counter == 1: nums.pop(i+1) l -= 1 elif nums[i] == nums[i+1] and counter == 0: counter += 1 i += 1 else: i += 1 counter = 0 return len(nums)
@minhvulai_yt Жыл бұрын
This is my solution -------------------------------------- class Solution: def removeDuplicates(self, nums: List[int]) -> int: if len(nums) < 2: return len(nums) pointer = 2 for num in nums[2:]: if nums[pointer-2] != num: nums[pointer] = num pointer += 1 return pointer -------------------------------------- So basically, if the length of an array is less than 3, obviously everything is already sorted and correctly placed, therefore we just return it. The if condition in the beginning also allows us to start checking from the third element as well. After that we just start checking our current element and the one that is 2 steps behind. If there are equal, it means that the last two elements in the array are already equal to the current one and therefore we cannot place another one (it would be the third). In other cases, it is possible to add another element with the same value
@Dan-dg2pc Жыл бұрын
There is an easier solution where R (right pointer) loops through the array and just checks whether nums[R] == nums[L] == nums[L-1]. If not: L += 1 nums[L] = nums[R] If yes: continue Return: L+1 JS: var removeDuplicates = function(nums) { if (nums.length < 3) return nums.length // Handle edgecase let replaceIndex = 1 for (let i = 2 ; i < nums.length ; i++) { if (nums[i] != nums[replaceIndex] || nums[replaceIndex] != nums[replaceIndex-1]) { replaceIndex++ nums[replaceIndex] = nums[i] } } return replaceIndex+1 };
@arkajyotisaha6061 Жыл бұрын
are these questions prasent in NeetCodeAll ?
@shavvasatya7131 Жыл бұрын
Will not prasent 😀
@Maximumist2 ай бұрын
heres a solution in c++: class Solution { public: int removeDuplicates(vector& nums) { int k = 2; if (nums.size()
@ppk9527 Жыл бұрын
You rock!
@CST19929 ай бұрын
There's a bug in this problem(the problem itself, not the solution): It says it wants to remove duplicates in the title and it says in the description that each element will appear *at most* twice. It's quite normal to reason that this means that any element, even which originally has 2 copies of a given value in it, can be trimmed down to 1 copy. But that is forbidden: you have to leave *both* copies in the output for it to be what is expected. So, the description needs to be changed to "at least and at most" twice: If the original has only one of the given, fine; but if it contains two or more copies of the same value, you have to leave at least two in and remove the rest. Of course, the value of k needs to be set to factor this in.
@pranavmaniyar45923 ай бұрын
Good question
@S5Dic098 ай бұрын
geez before 5m you make this so redundant tbh that removes clarity
@JasonKAls9 ай бұрын
Doesn't this have a crazy time complexity like O(n^2) or even O(n^3) since he has a nested while loop and a for loop in within it?
@mahmoudabdaltwab42610 ай бұрын
whoever strugle to understand this sol i think this easier to come up with int removeDuplicates(vector& nums) { ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr); if(nums.size()
@handsomeabu Жыл бұрын
Please make a video on sliding window median
@nirupomboseroy606711 ай бұрын
An even more intuitive solution. O(n) class Solution: def removeDuplicates(self, nums: List[int]) -> int: if len(nums) == 1: return l = 0 r = 0 while r < len(nums): # edge case if l == 0 and nums[l+1] == nums[l]: # skip the first value to continue as usual r+=1 l+=1 if nums[r] != nums[l]: l+=1 nums[l] = nums[r] # Greedily check for one more duplicate as it is two # if we get it we change else no problem. if r+1 < len(nums) and nums[r+1] == nums[r]: l+=1 nums[l] = nums[r] r+=1 r+=1 return l+1
@ratantejaswivadapalli159110 ай бұрын
l,c = 1,1 for r in range(1,len(nums)): if(nums[r]!=nums[r-1]): c = 1 nums[l]=nums[r] l += 1 else: if c
@FUNTasticFlutter9 ай бұрын
my solution : runtime 57 ms. mem 16.64 mb code for n in nums: if nums.count(n)>2: while nums.count(n)>2: nums.remove(n) return len(nums)
@gaganbhattacharya9890 Жыл бұрын
I would rather prefer to use a dictionary & if value for key > 2, pop the value & finally return the len(nums).
@abdullahamin613811 ай бұрын
Can be done in O(n)...
@yasarapudurgabhavani3985 Жыл бұрын
Good Evening Sir. I'm an Indian and trying to buy Ur Yearly Plan. I'm getting Ur card is declined. Please help me Sir .. I'm interested to crack MAANG interviews
@NeetCodeIO Жыл бұрын
Hi, please email me (neetcodebusiness@gmail.com)
@omar-eo8cq Жыл бұрын
you make this question hard, you can make it easier by starting left and right from index 2 and if(nums[right ]!==nums[left -2]){ nums[left ]=nums[right ]; we increment left ++ otherwise right ++ , finally return left
@akash5653 Жыл бұрын
Todays Daily Challenge?
@dera_ng Жыл бұрын
🙆♂️
@prasadm3614 Жыл бұрын
This is nice solution
@Mario_blandАй бұрын
I tried solving this today translating the code into javascript and 1337codes says it fails because there's more numbers after k. wtf? var removeDuplicates = function(nums) { let l = 0 let r = 0 while(r